您的位置:首页 > 其它

[Leetcode] 732. My Calendar III 解题报告

2018-03-01 10:58 453 查看
题目

Implement a 
MyCalendarThree
 class to store your events. A new event can always be
added.

Your class will have one method, 
book(int start, int end)
. Formally, this represents a
booking on the half open interval 
[start, end)
, the range of real numbers 
x
 such
that 
start <= x < end
.

A K-booking happens when K events have some non-empty intersection (ie., there is some time that is common to all K events.)

For each call to the method 
MyCalendar.book
, return an integer 
K
 representing
the largest integer such that there exists a 
K
-booking in the calendar.
Your class will be called like this: 
MyCalendarThree
cal = new MyCalendarThree();
 
MyCalendarThree.book(start,
end)


Example 1:

MyCalendarThree();
MyCalendarThree.book(10, 20); // returns 1
MyCalendarThree.book(50, 60); // returns 1
MyCalendarThree.book(10, 40); // returns 2
MyCalendarThree.book(5, 15); // returns 3
MyCalendarThree.book(5, 10); // returns 3
MyCalendarThree.book(25, 55); // returns 3
Explanation:
The first two events can be booked and are disjoint, so the maximum K-booking is a 1-booking.
The third event [10, 40) intersects the first event, and the maximum K-booking is a 2-booking.
The remaining events cause the maximum K-booking to be only a 3-booking.
Note that the last event locally causes a 2-booking, but the answer is still 3 because
eg. [10, 20), [10, 40), and [5, 15) are still triple booked.


Note:

The number of calls to 
MyCalendarThree.book
 per test case will be at most 
400
.
In calls to 
MyCalendarThree.book(start, end)
start
 and 
end
 are
integers in the range 
[0, 10^9]
.
思路

[Leetcode] 731. My Calendar II 解题报告的思路一致:我们首先计算s将覆盖多少个线段,以及计算哪些start points将覆盖线段[s,e),并更新其对应的count,最后将s插入map中。不过我们最后需要扫描一遍map,以便找出最多覆盖的线段数。这样算法的空间复杂度和时间复杂度都是O(n)。

我直觉这道题目也应该可以用线段树解决:每次遇到一个[s,e),则我们可以在O(logN)的时间复杂度内将其分割(如果有必要),并且加入到线段树中。最后遍历线段树中结点,找出其出现次数最多者,返回即可。不过这样算法的空间复杂度和时间复杂度仍然是O(n),没有本质上的提高。有兴趣的读者可以尝试实现。

代码

class MyCalendarThree {
public:
MyCalendarThree() {

}

int book(int start, int end) {
// step 1: find the segments that s covers
int cnt = 0;
for (auto &v : st) {
if (v.first <= start && v.second > start) {
++cnt;
}
}
// step 2: update the start points that cover [s,e)
for (auto it = mp.lower_bound(start); it != mp.end() && it->first < end; ++it) {
++it->second;
}
mp[start] = cnt + 1;
st.push_back({start, end});
cnt = 0;
for (auto it = mp.begin(); it != mp.end(); ++it) {
cnt = max(cnt, it->second);
}
return cnt;
}
private:
vector<pair<int,int>> st; // all the segments
map<int,int> mp; // map from start points to counts
};

/**
* Your MyCalendarThree object will be instantiated and called as such:
* MyCalendarThree obj = new MyCalendarThree();
* int param_1 = obj.book(start,end);
*/
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: